'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-fa857a86.js');
const ionicGlobal = require('./ionic-global-231411e0.js');
const theme = require('./theme-355c3f5d.js');

const cardSubtitleIosCss = ":host{display:block;position:relative;color:var(--color)}:host(.ion-color){color:var(--ion-color-base)}:host{--color:var(--ion-color-step-600, #666666);margin-left:0;margin-right:0;margin-top:0;margin-bottom:4px;padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;font-size:12px;font-weight:700;letter-spacing:0.4px;text-transform:uppercase}";

const cardSubtitleMdCss = ":host{display:block;position:relative;color:var(--color)}:host(.ion-color){color:var(--ion-color-base)}:host{--color:var(--ion-color-step-550, #737373);margin-left:0;margin-right:0;margin-top:0;margin-bottom:0;padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;font-size:14px;font-weight:500}";

const CardSubtitle = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
    }
    render() {
        const mode = ionicGlobal.getIonMode(this);
        return (index.h(index.Host, { role: "heading", "aria-level": "3", class: theme.createColorClasses(this.color, {
                'ion-inherit-color': true,
                [mode]: true
            }) }, index.h("slot", null)));
    }
};
CardSubtitle.style = {
    ios: cardSubtitleIosCss,
    md: cardSubtitleMdCss
};

exports.ion_card_subtitle = CardSubtitle;
