// Stencil
import { h, Component, Prop } from '@stencil/core';
export class PlacePresentationOpeningHours {
    constructor() {
        // Props
        this.openingHoursTitle = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            h("div", null,
                h("h4", { class: 'place-section-title' }, this.openingHoursTitle),
                h("div", { class: "opening-hours-container" },
                    h("slot", { name: "opening-hours" })))));
    }
    static get is() { return "place-presentation-opening-hours"; }
    static get originalStyleUrls() { return {
        "$": ["place-presentation-opening-hours.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["place-presentation-opening-hours.css"]
    }; }
    static get properties() { return {
        "openingHoursTitle": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "opening-hours-title",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
