export class Content {
    constructor(componentType) {
        this.id = null;
        this.componentType = componentType ? componentType : 0;
        this.data = {};
    }
}
////////////////////////////////////////////////////////////////
// Enumerations
////////////////////////////////////////////////////////////////
export var ComponentType;
(function (ComponentType) {
    ComponentType[ComponentType["NICE_TO_KNOW_CONTENT"] = 0] = "NICE_TO_KNOW_CONTENT";
    ComponentType[ComponentType["HAVE_A_LOOK_CONTENT"] = 1] = "HAVE_A_LOOK_CONTENT";
    ComponentType[ComponentType["DO_YOU_KNOW_CONTENT"] = 2] = "DO_YOU_KNOW_CONTENT";
    ComponentType[ComponentType["EXPERT_POINT_CONTENT"] = 3] = "EXPERT_POINT_CONTENT";
    ComponentType[ComponentType["TOP_FACTS_CONTENT"] = 4] = "TOP_FACTS_CONTENT";
    ComponentType[ComponentType["OPTIONAL_PLACE_ANNOUNCEMENT"] = 5] = "OPTIONAL_PLACE_ANNOUNCEMENT";
    ComponentType[ComponentType["MAIN_PLACE_ANNOUNCEMENT"] = 6] = "MAIN_PLACE_ANNOUNCEMENT";
    ComponentType[ComponentType["CONTENT_ANNOUNCEMENT"] = 7] = "CONTENT_ANNOUNCEMENT";
    ComponentType[ComponentType["EXPERT_INTRO_CONTENT"] = 8] = "EXPERT_INTRO_CONTENT";
    ComponentType[ComponentType["SYSTEM_ANNOUNCEMENT_CONTENT"] = 9] = "SYSTEM_ANNOUNCEMENT_CONTENT";
    ComponentType[ComponentType["USER_ACTION_CONTENT"] = 10] = "USER_ACTION_CONTENT";
    ComponentType[ComponentType["QUOTE_CONTENT"] = 11] = "QUOTE_CONTENT";
    ComponentType[ComponentType["COMPOSITION_LIST"] = 12] = "COMPOSITION_LIST";
    ComponentType[ComponentType["FEATURE_ICON_ELEMENT"] = 13] = "FEATURE_ICON_ELEMENT";
    ComponentType[ComponentType["FEATURE_IMAGE_ELEMENT"] = 14] = "FEATURE_IMAGE_ELEMENT";
    ComponentType[ComponentType["LIST_OVERVIEW"] = 15] = "LIST_OVERVIEW";
    ComponentType[ComponentType["MARKDOWN_CONTENT"] = 16] = "MARKDOWN_CONTENT";
    ComponentType[ComponentType["TOP_ELEMENT"] = 17] = "TOP_ELEMENT";
    ComponentType[ComponentType["TOP_SPECIALITIES"] = 18] = "TOP_SPECIALITIES";
    ComponentType[ComponentType["TRUE_FALSE_TEST_CONTENT"] = 19] = "TRUE_FALSE_TEST_CONTENT";
})(ComponentType || (ComponentType = {}));
export var ContentCallbackId;
(function (ContentCallbackId) {
    ContentCallbackId["START_TOUR"] = "startTour";
    ContentCallbackId["NEXT_PLACE"] = "nextPlace";
})(ContentCallbackId || (ContentCallbackId = {}));
