// Models
import { QuestionBase } from './question-model';
export class RangeQuestion extends QuestionBase {
    constructor(options = {}) {
        super('range', options);
        this.interface = ''; // action-sheet, popover or alert
        this.min = 0;
        this.max = 0;
        this.interface = options['interface'] || 'popover';
        this.min = options['min'] || 0;
        this.max = options['max'] || 100;
    }
}
