import { r as registerInstance, h, H as Host } from './index-9bc5455c.js';
import { g as getIonMode } from './ionic-global-54ea523e.js';
import { c as createColorClasses } from './theme-1706d6ff.js';
var noteIosCss = ":host{color:var(--color);font-family:var(--ion-font-family, inherit);-webkit-box-sizing:border-box;box-sizing:border-box}:host(.ion-color){color:var(--ion-color-base)}:host{--color:var(--ion-color-step-350, #a6a6a6)}";
var noteMdCss = ":host{color:var(--color);font-family:var(--ion-font-family, inherit);-webkit-box-sizing:border-box;box-sizing:border-box}:host(.ion-color){color:var(--ion-color-base)}:host{--color:var(--ion-color-step-600, #666666);font-size:14px}";
var Note = /** @class */ (function () {
    function Note(hostRef) {
        registerInstance(this, hostRef);
    }
    Note.prototype.render = function () {
        var _a;
        var mode = getIonMode(this);
        return (h(Host, { class: createColorClasses(this.color, (_a = {},
                _a[mode] = true,
                _a)) }, h("slot", null)));
    };
    return Note;
}());
Note.style = {
    ios: noteIosCss,
    md: noteMdCss
};
export { Note as ion_note };
