import { MediaElement } from '../../../models/media/media-model';
import { EventEmitter } from '../../../stencil-public-runtime';
export declare class MainPlaceAnnouncement {
    image: MediaElement;
    placeTitle: string;
    placeIndex: number;
    placeTotalCount: number;
    placeId: string;
    buttonText: string;
    clicked: boolean;
    mainPlaceClicked: EventEmitter<string>;
    /**
     * Click on the title
     */
    private onClick;
    /**
     * Replace .undefined extension by .jpg
     * Fix a bug
     * @param imageUrl
     */
    private fixImage;
    render(): any;
}
