export declare class CompositionList {
    private compositionSlider;
    elementWidth: number;
    listTitle: string;
    sliderOptions: any;
    randomId: number;
    /**
     * Override
     */
    componentDidLoad(): void;
    /**
     * Update the slider (must be called when an element has been added/or deleted)
     */
    updateSlider(): Promise<void>;
    /**
     * The user wants to display the previous composition
     */
    private previousComposition;
    /**
    * The user wants to display the next composition
    */
    private nextComposition;
    /**
     * Return an object containing the tour slider options
     */
    private getSliderOptions;
    /**
     * Return the Content slider
     */
    private getCompositionSlider;
    render(): any;
}
