import { MediaElement } from '../../../models/media/media-model';
import { EventEmitter } from '../../../stencil-public-runtime';
export declare class ExpertOverview {
    expertFirstName: string;
    expertLastName: string;
    suffix: string;
    fullPortraitButton: string;
    expertSpeciality: string;
    expertAvatar: MediaElement;
    expertDescription: string;
    portraitClick: EventEmitter;
    private workingExpertDescription;
    /**
     * Override
     */
    componentWillLoad(): void;
    /**
     * The user wants to see the portrait of the expert
     */
    private onPortraitClick;
    render(): any;
}
