import { Review } from '../../../models/feedback/review-model';
import { EventEmitter } from '../../../stencil-public-runtime';
export declare class FeedbackReviewContent {
    group: string;
    commentOnly: boolean;
    message: string;
    messageOfThanks: string;
    showMessageOfThanks: boolean;
    showSkipButton: boolean;
    showCancelButton: boolean;
    lightMode: boolean;
    positiveCommentLabel: string;
    negativeCommentLabel: string;
    neutralCommentLabel: string;
    cancelButton: string;
    skipButton: string;
    submitButton: string;
    review: Review;
    submitted: boolean;
    onSubmit: EventEmitter<Review>;
    /**
     * The user submits the form
     * @param e
     */
    handleSubmit(e: any): void;
    /**
     * The user cancels or skips the form
     * @param e
     */
    handleCancel(e: any): void;
    /**
     * The rating has changed
     * @param event
     */
    handleRatingChange(event: any): void;
    /**
     * The like comment has changed
     * @param event
     */
    handleLikeChange(event: any): void;
    /**
     * The dislike comment has changed
     * @param event
     */
    handleDislikeChange(event: any): void;
    /**
     * The comment has changed
     * @param event
     */
    handleCommentChange(event: any): void;
    renderMessageOfThanks(): any;
    render(): any;
}
