import { AnimationConfigWithData, AnimationConfigWithPath } from 'lottie-web/build/player/lottie.js';
/**
 * Copied from https://github.com/splitinfinities/lottie-wc
 * All of the following methods are not commented
 */
export declare class LottieAnimation {
    element: HTMLElement;
    animationData: string;
    src: string;
    loop: boolean;
    count: number;
    autoplay: boolean;
    controls: boolean;
    renderer: string;
    speed: number;
    direction: number;
    __paused: boolean;
    settings: AnimationConfigWithPath | AnimationConfigWithData;
    io: IntersectionObserver;
    status: string;
    lottie: any;
    play(): Promise<void>;
    pause(): Promise<void>;
    stop(): Promise<void>;
    setSpeed(value?: number): Promise<void>;
    setDirection(value?: number): Promise<void>;
    rendererSettings(settings: any): Promise<void>;
    instance(): Promise<any>;
    /**
      Renders the settings object and checks if the data is added via src or animationData element
     */
    update(settings: any): Promise<void>;
    /**
     * Override
     */
    private componentDidLoad;
    private load;
    private addIntersectionObserver;
    render(): any;
}
