import '@ionic/core';
import { EventEmitter } from '../../../stencil-public-runtime';
export declare class PresentationSlide {
    backgroundImage: string;
    overlay: number;
    alt: string;
    slideTitle: string;
    slideSubtitle: string;
    displayMessage: boolean;
    buttonTitle: string;
    buttonHref: string;
    isWeb: boolean;
    onStartButtonClicked: EventEmitter;
    /**
     * Receiver for the button click
     */
    onClick(): void;
    /**
     * Replace .undefined extension by .jpg
     * Fix a bug
     * @param imageUrl
     */
    private fixImage;
    render(): any;
}
