import { Coordinates } from '../coordinates/coordinates-model';
export declare class RawDirectionData {
    breakLocations_: DirectionCoordinates[];
    throughLocations_: DirectionCoordinates[];
    costing_: string;
    options_: DirectionOptions;
    breakLocations: DirectionCoordinates[];
    throughLocations: DirectionCoordinates[];
    costing: string;
    options: DirectionOptions;
    constructor(breakLocations_: DirectionCoordinates[], throughLocations_: DirectionCoordinates[], costing_: string, options_: DirectionOptions);
}
export declare class DirectionCoordinates extends Coordinates {
    lat: number;
    lon: number;
    id_?: number;
    id?: number;
    constructor(lat: number, lon: number, id_?: number);
}
export declare class DirectionOptions {
    units_: string;
    language_: string;
    units: string;
    language: string;
    constructor(units_: string, language_: string);
}
