/**
 * Define an instruction for a specific maneuver
 */
export declare class Instruction {
    preInstruction: string;
    preManeuverDistance: number;
    postInstruction: string;
    postManeuverDistance: number;
    userOverridden: boolean;
    state: InstructionState;
    constructor();
}
export declare enum InstructionState {
    draft = 0,
    validated = 1
}
