// Stencil
import { h, Component, Prop } from '@stencil/core';
export class DoYouKnowContent {
    constructor() {
        // Props
        this.name = 'Curious fact';
        this.fact = '';
        this.contentTitle = '';
        this.description = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            h("div", { class: 'main-container' },
                h("div", { class: 'header-container' },
                    h("p", { class: 'header-text' }, this.name)),
                h("div", { class: 'content-container' },
                    h("p", { class: 'title' }, this.contentTitle),
                    h("p", { class: 'description' }, this.description)))));
    }
    static get is() { return "do-you-know-content"; }
    static get originalStyleUrls() { return {
        "$": ["do-you-know-content.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["do-you-know-content.css"]
    }; }
    static get properties() { return {
        "name": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "name",
            "reflect": false,
            "defaultValue": "'Curious fact'"
        },
        "fact": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "fact",
            "reflect": false,
            "defaultValue": "''"
        },
        "contentTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "content-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "description": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "description",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
