// Constants
export var CompositionType;
(function (CompositionType) {
    CompositionType[CompositionType["TOUR"] = 0] = "TOUR";
    CompositionType[CompositionType["LIST"] = 1] = "LIST";
    CompositionType[CompositionType["PROGRAM"] = 2] = "PROGRAM";
})(CompositionType || (CompositionType = {}));
;
export class Composition {
    constructor() {
        this.id = null;
        this.name = '';
        this.introduction = '';
        this.description = '';
        this.price = '';
        this.duration = '';
        this.bestMoment = '';
        this.reasons = [];
        this.images = [];
        // Expert
        this.expertRef = '';
        this.expert = null;
        this.expertLoad = false;
        // Region
        this.regionRef = '';
        this.region = null;
        this.regionLoad = false;
        // Sublists
        this.sublistsRef = [];
        this.sublists = [];
        this.sublistsLoad = false;
        // Contents
        this.contentsRef = [];
        this.contents = [];
        this.contentsLoad = false;
    }
}
