// Models
import { QuestionBase } from './question-model';
export class MediaQuestion extends QuestionBase {
    constructor(options = {}) {
        super('media', options);
        this.mediaType = ''; // video;image;sound
        this.cameraDirection = ''; // front;back
        this.limit = -1; // Number of media to be added
        this.mediaType = options['mediaType'] || 'image';
        this.cameraDirection = options['cameraDirection'] || 'back';
        this.limit = options['limit'] || 10;
    }
}
