export class QuestionBase {
    constructor(controlType, options = {}) {
        this.controlType = controlType;
        this.key = '';
        this.label = '';
        this.placeholder = '';
        this.required = false;
        this.order = -1;
        this.value = options.value;
        this.key = options.key || '';
        this.label = options.label || '';
        this.placeholder = options.placeholder || '';
        this.required = !!options.required;
        this.order = options.order === undefined ? 1 : options.order;
    }
}
