/**
 * Define an instruction for a specific maneuver
 */
export class Instruction {
    constructor() {
        // General
        this.preInstruction = ''; // Text to display at the starting point
        this.preManeuverDistance = 0; // Distance before the maneuver
        this.postInstruction = ''; // Text to display after the success point
        this.postManeuverDistance = 0; // Distance from the maneuver to the next one
        this.preInstruction = '';
        this.postInstruction = '';
        this.userOverridden = false;
        this.state = InstructionState.draft;
    }
}
export var InstructionState;
(function (InstructionState) {
    InstructionState[InstructionState["draft"] = 0] = "draft";
    InstructionState[InstructionState["validated"] = 1] = "validated";
})(InstructionState || (InstructionState = {}));
