/**
 * Define a geographic path through main places
 */
export class Itinerary {
    constructor() {
        this.id = null;
        this.sublistRef = '';
        this.time = 0;
        this.length = 0;
        this.legs = [];
        // Starting point
        this.startingPointRef = '';
        this.startingPoint = null;
        this.startingPointLoad = true;
    }
}
////////////////////////////////////////////////////////////////
// Enumerations
////////////////////////////////////////////////////////////////
export var ItineraryMode;
(function (ItineraryMode) {
    ItineraryMode["PREVIEW"] = "preview";
    ItineraryMode["EFFECTIVE"] = "effective";
})(ItineraryMode || (ItineraryMode = {}));
