//////////////////////////////////////////////////////
// Export enums
//////////////////////////////////////////////////////
/**
* Describe the several states the location permission checking algorithm
* can issue
*/
export var LocationPermissionState;
(function (LocationPermissionState) {
    LocationPermissionState[LocationPermissionState["SUCCESS_SETTINGS_SATISFIED"] = 0] = "SUCCESS_SETTINGS_SATISFIED";
    LocationPermissionState[LocationPermissionState["ERROR_USER_DENIED"] = 1] = "ERROR_USER_DENIED";
    LocationPermissionState[LocationPermissionState["ERROR_USER_DENIED_ALWAYS"] = 2] = "ERROR_USER_DENIED_ALWAYS";
    LocationPermissionState[LocationPermissionState["ERROR_SYSTEM_LOCATION_ACCURACY"] = 3] = "ERROR_SYSTEM_LOCATION_ACCURACY";
    LocationPermissionState[LocationPermissionState["ERROR_SYSTEM_UNKNOWN"] = 4] = "ERROR_SYSTEM_UNKNOWN";
})(LocationPermissionState || (LocationPermissionState = {}));
