import { MediaElement } from '../../../models/media/media-model';
export declare class AudioContent {
    name: string;
    image: MediaElement[];
    audioTitle: string;
    audioSource: MediaElement[];
    script: string;
    transcriptLabel: string;
    sourceId: string;
    transcriptDisplayed: boolean;
    transcriptButtonDisplayed: boolean;
    /**
     * Display the transcript button when user clicks
     * on the play audio button
     */
    private displayTranscriptButton;
    /**
    * The user wants to display the transcript
    */
    private displayTranscript;
    render(): any;
}
