import { Question } from './Question';
import { EventEmitter } from '../../../stencil-public-runtime';
export declare class TrueFalseTestContent {
    name: string;
    questions: Question[];
    seeResultsLabel: string;
    nextLabel: string;
    falseLabel: string;
    trueLabel: string;
    resultsLabel: string;
    congratsLabel: string;
    displayAnswer: boolean;
    correctAnswer: boolean;
    isLastQuestion: boolean;
    questionCount: number;
    correctAnswerCount: number;
    closeModalClicked: EventEmitter<string>;
    testEnded: EventEmitter<string>;
    /**
     * Override
     */
    componentWillLoad(): void;
    /**
     * Override
     */
    componentDidLoad(): void;
    /**
     * Evaluate whether the answer is correct or incorrect
     * Display the answer
     * @param question
     * @param value
     */
    private answer;
    /**
     * Go to the next question
     */
    private nextQuestion;
    /**
     * Inform the test is finished
    */
    private endTest;
    /**
     * Close the Modal
    */
    private closeModal;
    /**
     * Get the Slides component from the DOM
     */
    private getSlides;
    render(): any;
}
