export declare class Content {
    id?: string;
    componentType: ComponentType;
    data: any;
    constructor(componentType?: number);
}
export declare enum ComponentType {
    NICE_TO_KNOW_CONTENT = 0,
    HAVE_A_LOOK_CONTENT = 1,
    DO_YOU_KNOW_CONTENT = 2,
    EXPERT_POINT_CONTENT = 3,
    TOP_FACTS_CONTENT = 4,
    OPTIONAL_PLACE_ANNOUNCEMENT = 5,
    MAIN_PLACE_ANNOUNCEMENT = 6,
    CONTENT_ANNOUNCEMENT = 7,
    EXPERT_INTRO_CONTENT = 8,
    SYSTEM_ANNOUNCEMENT_CONTENT = 9,
    USER_ACTION_CONTENT = 10,
    QUOTE_CONTENT = 11,
    COMPOSITION_LIST = 12,
    FEATURE_ICON_ELEMENT = 13,
    FEATURE_IMAGE_ELEMENT = 14,
    LIST_OVERVIEW = 15,
    MARKDOWN_CONTENT = 16,
    TOP_ELEMENT = 17,
    TOP_SPECIALITIES = 18,
    TRUE_FALSE_TEST_CONTENT = 19
}
export declare enum ContentCallbackId {
    START_TOUR = "startTour",
    NEXT_PLACE = "nextPlace"
}
