export declare abstract class QuestionBase<T> {
    controlType: string;
    value: T;
    key: string;
    label: string;
    placeholder: string;
    required: boolean;
    order: number;
    constructor(controlType: string, options?: {
        value?: T;
        key?: string;
        label?: string;
        placeholder?: string;
        required?: boolean;
        order?: number;
    });
}
