import { Leg } from './leg-model';
import { StartingPoint } from './starting-point-model';
/**
 * Define a geographic path through main places
 */
export declare class Itinerary {
    id?: string;
    sublistRef: string;
    time: number;
    length: number;
    legs: Leg[];
    readonly startingPointRef: string;
    readonly startingPoint: StartingPoint;
    startingPointLoad: boolean;
    constructor();
}
export declare enum ItineraryMode {
    PREVIEW = "preview",
    EFFECTIVE = "effective"
}
